#ifndef BUILD_cut_node
#define BUILD_cut_node
#include "RobboLito.h"
#include "history.i"
#include "null_move.i"

#include "cut_node.c"
#include "white.h"
#else
#include "black.h"
#endif

#define RETURN(x) return(x)

int
MyCut (typePOS *POSITION, int VALUE, int depth)
{
  int height, move, i, SINGULAR;
  int k;
  typeHash *tr;
  int trans_depth, move_depth = 0, trans_move = 0, Value, cnt;
  int v, EXT, new_depth, move_is_check;
  typeNEXT PROSSIMO[1];
  typeDYNAMIC *POS0 = DYN;
  uint64 zob = DYN->HASH;
  int to, fr;
  YUSUF128 H[1];
  boolean SPLIT;
  int SPLIT_ABISSO;

  if (VALUE < -VALUE_MATE + 1)
    RETURN (-VALUE_MATE + 1);
  if (VALUE > VALUE_MATE - 1)
    RETURN (VALUE_MATE - 1);
  (POS0 + 1)->move = 0;
  CheckRepetition;
  occupato5_verificare;
  k = zob & HashMask;

  for (i = 0; i < 4; i++)
    {
      tr = HashTable + (k + i);
      HYATT_HASH();
      if ((tr->hash ^ (zob >> 32)) == 0)
	{
	  trans_depth = tr->DepthLower;
	  move = tr->move;
	  if (move && trans_depth > move_depth)
	    {
	      move_depth = trans_depth;
	      (POS0 + 1)->move = trans_move = move;
	    }
	  trans_depth = MAX (tr->DepthLower, tr->DepthUpper);
	  if (tr->DepthLower >= depth)
	    {
	      Value = HashLowerBound (tr);
	      if (Value >= VALUE)
		{
		  if (!((tr->flags & FLAG_ALL) == FLAG_ALL))
		    if (MyNull || move)
		      {
			UPDATE_ANNI();
			RETURN (Value);
		      }
		}
	    }
	  if (tr->DepthUpper >= depth)
	    {
	      Value = HashUpperBound (tr);
	      if (Value < VALUE)
		{
		  UPDATE_ANNI();
		  RETURN (Value);
		}
	    }
	}
    }
  PROSSIMO->trans_move = trans_move;

  if (POS0->Value >= VALUE && MyNull)
    {
      MakeNull (POSITION);
      new_depth = depth - NULL_REDUCTION;
      new_depth -= ((uint32) (MIN (POS0->Value - VALUE, 96))) / 32;
      if (new_depth <= 1)
	v = -OppQsearch (POSITION, 1 - VALUE, 0);
      else if (new_depth <= 7)
	v = -OppLowDepth (POSITION, 1 - VALUE, new_depth);
      else
	v = -OppAll (POSITION, 1 - VALUE, new_depth);
      UndoNull (POSITION);
      CHECK_HALT ();
      if (v >= VALUE)
	{
	  if (trans_move == 0)
	    HashLower (DYN->HASH, 0, depth, v);
	  RETURN (v);
	}
    }

  if (trans_move == 0 && depth >= 6)
    {
      if (depth < 12)
	v = MyLowDepth (POSITION, VALUE, depth - 4);
      else
	v = MyCut (POSITION, VALUE, depth - 4);
      CHECK_HALT ();
      if (v >= VALUE)
	trans_move = (POS0 + 1)->move;
    }
  SINGULAR = 0;
  if (depth >= 16 && trans_move && MyOK (POSITION, trans_move))
    {
      v =
	MyExclude (POSITION, VALUE - depth, depth - MIN (12, depth / 2),
		     trans_move & 0x7fff);
      CHECK_HALT ();
      if (v < VALUE - depth)
	{
	  SINGULAR++;
	  height = HEIGHT (POSITION);
	  if (height * 4 <= depth)
	    SINGULAR++;
	  v =
	    MyExclude (POSITION, VALUE - 2 * depth, depth - MIN (12, depth / 2),
			 trans_move & 0x7fff);
	  CHECK_HALT ();
	  if (v < VALUE - 2 * depth)
	    {
	      SINGULAR++;
	      if (height * 8 <= depth)
		SINGULAR++;
	    }
	}
    }

  cnt = 0;
  PROSSIMO->trans_move = trans_move;
  PROSSIMO->phase = TRANS;
  PROSSIMO->TARGET = OppOccupied;
  if (depth < 20 && VALUE - POS0->Value >= 48 * (depth - 5))
    {
      PROSSIMO->phase = TRANS2;
      cnt = 1;
      if (VALUE - POS0->Value >= 48 * (depth - 2))
	PROSSIMO->TARGET ^= BitboardOppP;
    }
  PROSSIMO->move = 0;
  PROSSIMO->bc = 0;
  v = VALUE;

  SPLIT = FALSE;
  SPLIT_ABISSO = 16;

  while (TRUE)
    {
#if 1 && defined (YUSUF_MULTICORE)
      if (TITANIC_MODE && SMP_FREE != 0 && depth >= SPLIT_ABISSO && !SPLIT &&
          PROSSIMO->phase != TRANS && cnt >= 1  && PROSSIMO->phase <= ORDINARY_MOVES)
        {
          int r;
          boolean b;
          SPLIT = TRUE;
          b = IVAN_SPLIT (POSITION, PROSSIMO, depth, VALUE, VALUE, NODE_TYPE_CUT, &r);
          if (b)
            return r;
        }
#endif
      move = MyNext (POSITION, PROSSIMO);
      if (!move)
	break;
      to = TO (move);
      fr = FROM (move);
      if (IsRepetition (0))
	{
	  cnt++;
	  continue;
	}

      if (cnt > 5 && PROSSIMO->phase == ORDINARY_MOVES
	  && (move & 0xe000) == 0 && SqSet[fr] & ~MyXRAY
	  && depth < 20)
	{
	  if ((1 << (depth - 6)) + MAX_POSITIONAL (move) +
	      (POS0->Value) < VALUE + 35 + 2 * cnt)
	    {
	      cnt++;
	      continue;
	    }
	}
      move &= 0x7fff;
      MAKE (POSITION, move);
      EvalLazy (VALUE, VALUE, LazyValue2, move);

      if (ILLEGAL_MOVE)
	{
	  UNDO (POSITION, move);
	  continue;
	}
      if (MOVE_IS_CHECK)
	move_is_check = 1;
      else
	move_is_check = 0;

      if (move != PROSSIMO->trans_move)
	SINGULAR = 0;
      EXT = 0;
      if (move == PROSSIMO->trans_move)
	{
	  if (PassedPawnPush (to, FOURTH_RANK (to)))
	    EXT = 1;
	}
      else
	{
	  if (PassedPawnPush (to, SIXTH_RANK (to)))
	    EXT = 1;
	}
      if (PROSSIMO->trans_move == move
	  && TO ((POS1 - 1)->move) == TO (POS1->move)
	  && (POS1 - 1)->cp != 0)
	EXT++;
      EXT = MAX (EXT, SINGULAR);

      if (move_is_check)
	{
	  new_depth = depth - 2 + MAX (1, EXT);
	  v = -OppAllCheck (POSITION, 1 - VALUE, new_depth);
	}
      else
	{
	  if (cnt > 2 && depth < 20 && POS1->cp == 0
	      && (2 << (depth - 6)) - POS1->Value < VALUE + cnt - 15)
	    {
	      UNDO (POSITION, move);
	      cnt++;
	      continue;
	    }
	  if (PROSSIMO->phase == ORDINARY_MOVES && !EXT)
	    {
	      new_depth = depth - 2 + EXT - (4 + BSR (4 + cnt));
	      if (new_depth <= 1)
		v = -OppQsearch (POSITION, 1 - VALUE, 0);
	      else if (new_depth <= 7)
		v = -OppLowDepth (POSITION, 1 - VALUE, new_depth);
	      else
		v = -OppAll (POSITION, 1 - VALUE, new_depth);
	      if (v < VALUE)
		goto MYOUT;
	    }
	  new_depth = depth - 2 + EXT;
	  if (new_depth <= 7)
	    v = -OppLowDepth (POSITION, 1 - VALUE, new_depth);
	  else
	    v = -OppAll (POSITION, 1 - VALUE, new_depth);
	}
    MYOUT:
      UNDO (POSITION, move);
      CHECK_HALT ();
      cnt++;
      if (v >= VALUE)
	{
	  if ((POS0 + 1)->cp == 0 && MoveHistory (move))
	    HISTORY_GOOD (move, depth);
	  HashLower (DYN->HASH, move, depth, v);
	  RETURN (v);
	}
      if ((POS0 + 1)->cp == 0 && MoveHistory (move))
	HISTORY_BAD (move, depth);
    }
  if (!cnt && PROSSIMO->phase <= TRANS2)
    RETURN (0);
  v = VALUE - 1;
  HashUpperCUT (POSITION, depth, v);
  RETURN (v);
}

int
MyCutCheck (typePOS *POSITION, int VALUE, int depth)
{
  int height, move, k, cnt, REDUCTION, EXT;
  int trans_depth, move_depth = 0, trans_move = 0, Value, new_depth, v, i;
  typeHash *tr;
  typeMoveList LIST[256], *list, *p, *q;
  uint64 zob = DYN->HASH;
  int best_value, SINGULAR;
  typeDYNAMIC *POS0 = DYN;
  boolean GEN;
  YUSUF128 H[1];

  if (VALUE < -VALUE_MATE + 1)
    RETURN (-VALUE_MATE + 1);
  if (VALUE > VALUE_MATE - 1)
    RETURN (VALUE_MATE - 1);
  (POS0 + 1)->move = 0;
  CheckRepetition;
  occupato5_verificare;
  k = zob & HashMask;

  for (i = 0; i < 4; i++)
    {
      tr = HashTable + (k + i);
      HYATT_HASH();
      if ((tr->hash ^ (zob >> 32)) == 0)
	{
	  trans_depth = tr->DepthLower;
	  move = tr->move;
	  if (move && trans_depth > move_depth)
	    {
	      move_depth = trans_depth;
	      (POS0 + 1)->move = trans_move = move;
	    }
	  trans_depth = MAX (tr->DepthLower, tr->DepthUpper);
	  if (tr->DepthLower >= depth)
	    {
	      Value = HashLowerBound (tr);
	      if (Value >= VALUE)
		{
		  if (!((tr->flags & FLAG_ALL) == FLAG_ALL))
		    {
		      UPDATE_ANNI();
		      RETURN (Value);
		    }
		}
	    }
	  if (tr->DepthUpper >= depth)
	    {
	      Value = HashUpperBound (tr);
	      if (Value < VALUE)
		{
		  UPDATE_ANNI();
		  RETURN (Value);
		}
	    }
	}
    }
  if (trans_move && !MyOK (POSITION, trans_move))
    trans_move = 0;

  best_value = HEIGHT (POSITION) - VALUE_MATE;
  SINGULAR = 0;
  if (depth >= 16 && trans_move)
    {
      v =
	MyExcludeCheck (POSITION, VALUE - depth,
			    depth - MIN (12, depth / 2), trans_move & 0x7fff);
      CHECK_HALT ();
      if (v < VALUE - depth)
	{
	  SINGULAR++;
	  height = HEIGHT (POSITION);
	  if (height * 4 <= depth)
	    SINGULAR++;
	  v =
	    MyExcludeCheck (POSITION, VALUE - 2 * depth,
				depth - MIN (12, depth / 2),
				trans_move & 0x7fff);
	  CHECK_HALT ();
	  if (v < VALUE - 2 * depth)
	    {
	      SINGULAR++;
	      if (height * 8 <= depth)
		SINGULAR++;
	    }
	}
    }

  p = LIST;
  LIST[0].move = trans_move;
  cnt = 0;
  GEN = FALSE;
  LIST[1].move = 0;
  while (p->move || !GEN)
    {
      if (!p->move)
	{
	  list = MyEvasion (POSITION, LIST + 1, 0xffffffffffffffff);
	  GEN = TRUE;
	  for (p = list - 1; p >= LIST + 1; p--)
	    {
	      if ((p->move & 0x7fff) == trans_move)
		p->move = 0;
	      else if (p->move <= (0x80 << 24))
		{
		  if ((p->move & 0x7fff) == POS0->killer1)
		    p->move |= 0x7fff8000;
		  else if ((p->move & 0x7fff) == POS0->killer2)
		    p->move |= 0x7fff0000;
		  else
		    p->move |=
		      (p->move & 0x7fff) |
		      (HISTORY_VALUE (POSITION, p->move) << 15);
		}
	      move = p->move;
	      for (q = p + 1; q < list; q++)
		{
		  if (move < q->move)
		    (q - 1)->move = q->move;
		  else
		    break;
		}
	      q--;
	      q->move = move;
	    }
	  p = LIST + 1;
	  continue;
	}
      move = p->move & 0x7fff;
      p++;
      if (move != trans_move)
	SINGULAR = 0;
      if (IsRepetition (0))
	{
	  cnt++;
	  best_value = MAX (0, best_value);
	  continue;
	}
      MAKE (POSITION, move);
      EvalLazy (VALUE, VALUE, LazyValue2, move);
      if (ILLEGAL_MOVE)
	{
	  UNDO (POSITION, move);
	  continue;
	}
      if (MOVE_IS_CHECK)
	{
	  new_depth = depth - 2;
	  if (SINGULAR)
	    new_depth += SINGULAR;
	  else
	    new_depth++;
	  if (new_depth <= 7)
	    v = -OppLowDepthCheck (POSITION, 1 - VALUE, new_depth);
	  else
	    v = -OppAllCheck (POSITION, 1 - VALUE, new_depth);
	}
      else
	{
	  if (cnt >= 1)
	    {
	      if (depth > 8)
		REDUCTION = BSR (depth - 7);
	      else
		REDUCTION = 0;
	      REDUCTION += 1 + MIN (cnt, 2);
	      if (EARLY_GAME)
		EXT = 1;
	      else
		EXT = 0;
	      new_depth = depth + EXT - REDUCTION - 2;
	      if (new_depth <= 1)
		v = -OppQsearch (POSITION, 1 - VALUE, 0);
	      else if (new_depth <= 7)
		v = -OppLowDepth (POSITION, 1 - VALUE, new_depth);
	      else
		v = -OppAll (POSITION, 1 - VALUE, new_depth);
	      if (v < VALUE)
		goto LOOP;
	    }
	  if (!SINGULAR && EARLY_GAME)
	    EXT = 1;
	  else
	    EXT = 0;
	  new_depth = depth - 2 + EXT + SINGULAR;
	  if (new_depth <= 7)
	    v = -OppLowDepth (POSITION, 1 - VALUE, new_depth);
	  else
	    v = -OppAll (POSITION, 1 - VALUE, new_depth);
	}
    LOOP:
      UNDO (POSITION, move);
      CHECK_HALT ();
      if (v > best_value)
	best_value = v;
      if (v < VALUE)
	{
	  cnt++;
	  continue;
	}
      HashLower (DYN->HASH, move, MAX (1, depth), v);
      RETURN (v);
    }
  HashUpperCUT (POSITION, MAX (1, depth), best_value);
  RETURN (best_value);
}

