
static INLINE void
MakeNull (typePOS *POSITION)
{
  POSITION->nodes++;
  DYN->SAVED_FLAGS = DYN->flags;
  memcpy (DYN + 1, DYN, 64);
  DYN++;
  DYN->HASH ^= ZobristWTM;
  POSITION->wtm ^= 1;
  POSITION->height++;
  DYN->reversible++;
  if (DYN->ep)
    {
      DYN->HASH ^= ZobristEP[DYN->ep & 7];
      DYN->ep = 0;
    }
  DYN->Value = -((DYN - 1)->Value + TempoValue);
  DYN->positional_valu = (DYN - 1)->positional_valu;
  DYN->lazy = (DYN - 1)->lazy;
  DYN->flags &= ~3;
  DYN->move = 0;
  STACK[++StackHeight] = DYN->HASH;
  VALIDATE (POSITION, 0, MOVE_NONE);
}

static INLINE void
UndoNull (typePOS *POSITION)
{
  DYN--;
  StackHeight--;
  POSITION->height--;
  POSITION->wtm ^= 1;
  DYN->flags = DYN->SAVED_FLAGS;
  VALIDATE (POSITION, 1, MOVE_NONE);
}

#define NULL_REDUCTION 8
